library SQLite_RegEx_Extension;

uses
  System.SysUtils,
  System.Classes,
  System.RegularExpressions;

const
  SQLITE_UTF8 = 1;

type
  TSqlite3_Context = Pointer;
  TSqlite3 = Pointer;
  PRegEx = ^TRegEx;
  TSqlite3_Value = Pointer;
  TSqlite3ValueArray = array[0..(MaxInt div 16)] of TSqlite3_Value;
  PSqlite3ValueArray = ^TSqlite3ValueArray;

  TFarProc = Pointer;

  TSqlite3_Get_Auxdata = function( context: TSqlite3_Context;
    N: Integer ): Pointer; cdecl;

  TSqlite3_Set_Auxdata = function( context: TSqlite3_Context; N: Integer;
    value: Pointer; dstrctr: Pointer): Pointer; cdecl;

  TSqlite3_Value_Text = function( Value: TSqlite3_Value ): PAnsiChar; cdecl;

  TSqlite3_Result_Int = procedure ( context: TSqlite3_Context;
    Value: Integer ); cdecl;

  TSqlite3_Result_Error = procedure( context: TSqlite3_Context; msg: PAnsiChar;
    code: Integer); cdecl;

  TSQLite3_Create_Function = function (db: TSqlite3; zFunctionName: PAnsiChar;
    nArg: Integer; eTextRep: Integer; pApp: Pointer; xFunc: TFarProc;
    xStep: TFarProc; xFinal: TFarProc): Integer; cdecl;

  TSqlite3_Api_Routines = record
    aggregate_context : TFarProc;
    aggregate_count : TFarProc;
    bind_blob : TFarProc;
    bind_double : TFarProc;
    bind_int : TFarProc;
    bind_int64 : TFarProc;
    bind_null : TFarProc;
    bind_parameter_count : TFarProc;
    bind_parameter_index : TFarProc;
    bind_parameter_name : TFarProc;
    bind_text : TFarProc;
    bind_text16 : TFarProc;
    bind_value : TFarProc;
    busy_handler : TFarProc;
    busy_timeout : TFarProc;
    changes : TFarProc;
    close : TFarProc;
    collation_needed : TFarProc;
    collation_needed16 : TFarProc;
    column_blob : TFarProc;
    column_bytes : TFarProc;
    column_bytes16 : TFarProc;
    column_count : TFarProc;
    column_database_name : TFarProc;
    column_database_name16 : TFarProc;
    column_decltype : TFarProc;
    column_decltype16 : TFarProc;
    column_double : TFarProc;
    column_int : TFarProc;
    column_int64 : TFarProc;
    column_name : TFarProc;
    column_name16 : TFarProc;
    column_origin_name : TFarProc;
    column_origin_name16 : TFarProc;
    column_table_name : TFarProc;
    column_table_name16 : TFarProc;
    column_text : TFarProc;
    column_text16 : TFarProc;
    column_type : TFarProc;
    column_value : TFarProc;
    commit_hook : TFarProc;
    complete : TFarProc;
    complete16 : TFarProc;
    create_collation : TFarProc;
    create_collation16 : TFarProc;
    create_function : TSQLite3_Create_Function;
    create_function16 : TFarProc;
    create_module : TFarProc;
    data_count : TFarProc;
    db_handle : TFarProc;
    declare_vtab : TFarProc;
    enable_shared_cache : TFarProc;
    errcode : TFarProc;
    errmsg : TFarProc;
    errmsg16 : TFarProc;
    exec : TFarProc;
    expired : TFarProc;
    finalize : TFarProc;
    free : TFarProc;
    free_table : TFarProc;
    get_autocommit : TFarProc;
    get_auxdata : TSqlite3_Get_Auxdata;
    get_table : TFarProc;
    global_recover : TFarProc;
    interruptx : TFarProc;
    last_insert_rowid : TFarProc;
    libversion : TFarProc;
    libversion_number : TFarProc;
    malloc : TFarProc;
    mprintf : TFarProc;
    open : TFarProc;
    open16 : TFarProc;
    prepare : TFarProc;
    prepare16 : TFarProc;
    profile : TFarProc;
    progress_handler : TFarProc;
    realloc : TFarProc;
    reset : TFarProc;
    result_blob : TFarProc;
    result_double : TFarProc;
    result_error : TSqlite3_Result_Error;
    result_error16 : TFarProc;
    result_int : TSqlite3_Result_Int;
    result_int64 : TFarProc;
    result_null : TFarProc;
    result_text : TFarProc;
    result_text16 : TFarProc;
    result_text16be : TFarProc;
    result_text16le : TFarProc;
    result_value : TFarProc;
    rollback_hook : TFarProc;
    set_authorizer : TFarProc;
    set_auxdata : TSqlite3_Set_Auxdata;
    snprintf : TFarProc;
    step : TFarProc;
    table_column_metadata : TFarProc;
    thread_cleanup : TFarProc;
    total_changes : TFarProc;
    trace : TFarProc;
    transfer_bindings : TFarProc;
    update_hook : TFarProc;
    user_data : TFarProc;
    value_blob : TFarProc;
    value_bytes : TFarProc;
    value_bytes16 : TFarProc;
    value_double : TFarProc;
    value_int : TFarProc;
    value_int64 : TFarProc;
    value_numeric_type : TFarProc;
    value_text : TSqlite3_Value_Text;
    value_text16 : TFarProc;
    value_text16be : TFarProc;
    value_text16le : TFarProc;
    value_type : TFarProc;
    vmprintf : TFarProc;
    overload_function : TFarProc;
    prepare_v2 : TFarProc;
    prepare16_v2 : TFarProc;
    clear_bindings : TFarProc;
    create_module_v2 : TFarProc;
    bind_zeroblob : TFarProc;
    blob_bytes : TFarProc;
    blob_close : TFarProc;
    blob_open : TFarProc;
    blob_read : TFarProc;
    blob_write : TFarProc;
    create_collation_v2 : TFarProc;
    file_control : TFarProc;
    memory_highwater : TFarProc;
    memory_used : TFarProc;
    mutex_alloc : TFarProc;
    mutex_enter : TFarProc;
    mutex_free : TFarProc;
    mutex_leave : TFarProc;
    mutex_try : TFarProc;
    open_v2 : TFarProc;
    release_memory : TFarProc;
    result_error_nomem : TFarProc;
    result_error_toobig : TFarProc;
    sleep : TFarProc;
    soft_heap_limit : TFarProc;
    vfs_find : TFarProc;
    vfs_register : TFarProc;
    vfs_unregister : TFarProc;
    xthreadsafe : TFarProc;
    result_zeroblob : TFarProc;
    result_error_code : TFarProc;
    test_control : TFarProc;
    randomness : TFarProc;
    context_db_handle : TFarProc;
    extended_result_codes : TFarProc;
    limit : TFarProc;
    next_stmt : TFarProc;
    sql : TFarProc;
    status : TFarProc;
    backup_finish : TFarProc;
    backup_init : TFarProc;
    backup_pagecount : TFarProc;
    backup_remaining : TFarProc;
    backup_step : TFarProc;
    compileoption_get : TFarProc;
    compileoption_used : TFarProc;
    create_function_v2 : TFarProc;
    db_config : TFarProc;
    db_mutex : TFarProc;
    db_status : TFarProc;
    extended_errcode : TFarProc;
    log : TFarProc;
    soft_heap_limit64 : TFarProc;
    sourceid : TFarProc;
    stmt_status : TFarProc;
    strnicmp : TFarProc;
    unlock_notify : TFarProc;
    wal_autocheckpoint : TFarProc;
    wal_checkpoint : TFarProc;
    wal_hook : TFarProc;
    blob_reopen : TFarProc;
    vtab_config : TFarProc;
    vtab_on_conflict : TFarProc;
  end;

  PSqlite3_Api_Routines = ^TSqlite3_Api_Routines;

var
  pApi : PSqlite3_Api_Routines;

procedure regex_destructor( aux_data: Pointer); cdecl;
var
  p : PRegEx;
begin
  if aux_data <> nil then
  begin
    p := aux_data;
    Dispose( p );
  end;
end;

procedure regex( context: TSqlite3_Context; argc: Integer;
  args: PSqlite3ValueArray); cdecl;
var
  target, pattern : PAnsiChar;
  wtarget, wpattern : string;
  preg : PRegEx;
  nRet : Integer;
  s : UTF8String;
begin
  try
    nRet := 0;
    if argc >= 2 then
    begin
      preg := pApi.get_auxdata( context, 1 );

      if preg = nil then
      begin
        wpattern := '';
        pattern :=  pApi.value_text(args^[1]);
        if pattern <> nil then
        begin
          wpattern := UTF8ToUnicodeString( pattern );
        end;

        New( preg );
        preg.Create( wpattern, [roIgnoreCase]);
        pApi.set_auxdata( context, 1, preg, @regex_destructor );
      end;

      target := pApi.value_text( args^[0]);
      if (target <> nil) then
      begin
        wtarget := UTF8ToUnicodeString( target );
        if wtarget <> '' then
        begin
          if preg.IsMatch( wtarget ) then
          begin
            nRet := 1;
          end;
        end;
      end;
    end;
    pApi.result_int( context, nRet);
  except
    on E: Exception do
    begin
      s := UTF8Encode( 'regex error!! ' + E.Message);
      pApi.result_error( context, Pointer(s), -1 );
    end;
  end;
end;

function sqlite3_extension_init(db: Pointer; pzErrMsg: PPAnsiChar;
  p: PSqlite3_Api_Routines): Integer; cdecl;
var
  sFuncName : AnsiString;
begin
  pApi := p;
  sFuncName := 'regex';
  pApi.create_function( db, PAnsiChar(sFuncName), 2, SQLITE_UTF8, nil, @regex,
    nil, nil );
  Result := 0;
end;

exports
  sqlite3_extension_init;

{$R *.res}

begin

end.
